-- This file is part of Bindings-bfd.
--
-- Copyright (C) 2010 Michael Nelson
--
-- Bindings-bfd is free software: you can redistribute it and/or modify
-- it under the terms of the GNU Lesser General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- Bindings-bfd is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU Lesser General Public License for more details.

-- You should have received a copy of the GNU Lesser General Public License
-- along with Bindings-bfd.  If not, see <http://www.gnu.org/licenses/>.

module Bindings.Bfd.Relocation where

import Foreign.Ptr
import Foreign.Storable

import Bindings.Bfd.Symbol

#include <bfd.h>


data Relocation = Relocation {
                       ptrSymbol :: Ptr Symbol
                     , address   :: Int
                     , addend    :: Int
--                   , howto     :: ?
                  }
     deriving Show

instance Storable Relocation where
   sizeOf _ = #size arelent
   alignment = sizeOf
   peek buf =
      do
         psym <- (#peek arelent, sym_ptr_ptr) buf
         addr <- (#peek arelent, address    ) buf
         adde <- (#peek arelent, addend     ) buf
         return $ Relocation psym addr adde

getSymbol
   :: Relocation
   -> IO Symbol
getSymbol (Relocation ps _ _) = peek ps

